> For the complete documentation index, see [llms.txt](https://docs.appkickstarter.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.appkickstarter.com/tech-things/dependency-injection.md).

# Dependency injection

There are 2 main packages in AppKickstarter. \
One is template with the base of the template and one is app.&#x20;

In app there is a appModule.kt file where there is a demo with a simple app that creates posts and list them on a paginated list. The screen models, datasources and use cases are defined in this appModule . You would want to override this, clear all the appModule and create your own unique application.&#x20;

```
val appModule = module {
    factoryOf(::AddPostScreenModel)
    factoryOf(::PostsListScreenModel) 
    singleOf(::AddPost)
    singleOf(::PostsFirestore)
    singleOf(::SavePostPicture)
}

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.appkickstarter.com/tech-things/dependency-injection.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
